searchNodes=[{"ref":"ExWindspeed.html","title":"ExWindspeed","type":"module","doc":"Functions for reading data from a windspeed sensor connected through an MCP3008 analog to digital chip. Hardware ExWindspeed was built to support a windspeed sensor purchased from Adafruit, Anemometer Wind Speed Sensor w/Analog Voltage Output. To communicate with the device from a RaspberryPi the signal is required to be digital as there are no analog inputs on the RaspberryPi. Using a MCP3008 analog to digital chip allows communication with up to 8 channels of 10-bit analog input. Follow the wiring section Specifics Output: 0.4V to 2V Testing Range: 0.5m/s to 50m/s Start wind speed: 0.2 m/s Resolution: 0.1m/s Accuracy: Worst case 1 m/s Max Wind Speed: 70m/s Connector details: Pin 1 - Power (brown wire) Pin 2 - Ground (black wire) Pin 3 - Signal (blue wire) Pin 4 - Not connected The Signal wire should be connected to one of the channels described below. Wiring MCP3008 ADC (Analog to Digital Converter) Channels Connections to PI ____ 0 -| |- 3.3V 1 -| |- 3.3V 2 -| |- Ground 3 -| |- Pin 18 4 -| |- Pin 23 5 -| |- Pin 24 6 -| |- Pin 25 7 -|____|- Ground Configuration ExWindspeed supports local development by having the sensor implementation configurable. By default the Raspberry PI implementation is used and expects hardware to be connected. SPI Device The device to communicate with via SPI can be configured with the device key. If the device key is not configured the default SPI device will be spidev0.0. SPI Transmission Data Data is transmitted to the SPI device and tells the chip which channel to read from. The default bitstring will read from channel 0, if you are using another channel you can set the bitstring to use with the spi_transfer_payload key. Local Development If you wish to use ExWindspeed during local development the ExWindspeed.Platform.Host.SensorImpl should be used. config :ex_windspeed, implementation: ExWindspeed.Platform.Host.SensorImpl With the configuration shown above, all calls to ExWindspeed.read/0 shall return the same windspeed with the current UTC DateTime for read_at. Example Configuration The defaults are used for this example. config :ex_windspeed, implementation: ExWindspeed.Platform.RPI.SensorImpl, device: &quot;spidev0.0&quot;, spi_transfer_payload: &lt;&lt;0x01, 0x80, 0x00&gt;&gt;"},{"ref":"ExWindspeed.html#read/0","title":"ExWindspeed.read/0","type":"function","doc":"Read current wind speed from sensor"},{"ref":"ExWindspeed.html#t:meters_per_second/0","title":"ExWindspeed.meters_per_second/0","type":"type","doc":"Windspeed in meters per second."},{"ref":"ExWindspeed.html#t:miles_per_hour/0","title":"ExWindspeed.miles_per_hour/0","type":"type","doc":"Windspeed in miles per hour."},{"ref":"ExWindspeed.html#t:read_at/0","title":"ExWindspeed.read_at/0","type":"type","doc":"Date and time in UTC (using local device time) that the data was read from the sensor. If your nerves project doesn&#39;t use a means to sync local time this value will be useless."},{"ref":"ExWindspeed.html#t:t/0","title":"ExWindspeed.t/0","type":"type","doc":"Struct containing wind speed from the sensor."},{"ref":"ExWindspeed.Conversions.html","title":"ExWindspeed.Conversions","type":"module","doc":"Provides functions for converting between formats. Examples iex&gt; ExWindspeed.Conversions.from_counts_to_volts(100) 0.3225806451612903 iex&gt; ExWindspeed.Conversions.from_volts_to_ms(0.52) 2.4299999999999997 iex&gt; ExWindspeed.Conversions.from_ms_to_mph(2.0250000000000004) 4.53 iex&gt; ExWindspeed.Conversions.from_celsius_to_fahrenheit(1) 33.8"},{"ref":"ExWindspeed.Conversions.html#from_celsius_to_fahrenheit/1","title":"ExWindspeed.Conversions.from_celsius_to_fahrenheit/1","type":"function","doc":"Converts from celsius to fahrenheit. The final temperature value is trimmed to 2 decimal places."},{"ref":"ExWindspeed.Conversions.html#from_counts_to_volts/1","title":"ExWindspeed.Conversions.from_counts_to_volts/1","type":"function","doc":"Converts counts to volts"},{"ref":"ExWindspeed.Conversions.html#from_ms_to_mph/1","title":"ExWindspeed.Conversions.from_ms_to_mph/1","type":"function","doc":"Converts from meters per second to miles per hour. The final miles per hour value is trimmed to 2 decimal points."},{"ref":"ExWindspeed.Conversions.html#from_volts_to_ms/1","title":"ExWindspeed.Conversions.from_volts_to_ms/1","type":"function","doc":"Converts volts to meters per second"},{"ref":"ExWindspeed.Error.html","title":"ExWindspeed.Error","type":"module","doc":"Struct for containing errors when interacting with the sensor."},{"ref":"ExWindspeed.Error.html#t:reason/0","title":"ExWindspeed.Error.reason/0","type":"type","doc":"Reason for failure when reading from sensor."},{"ref":"ExWindspeed.Error.html#t:t/0","title":"ExWindspeed.Error.t/0","type":"type","doc":"Struct representing a failure when reading data from the wind speed sensor."},{"ref":"ExWindspeed.Options.html","title":"ExWindspeed.Options","type":"module","doc":"Configuration module built from Application.get_all_env/1."},{"ref":"ExWindspeed.Options.html#get/0","title":"ExWindspeed.Options.get/0","type":"function","doc":"Gets configuration"},{"ref":"ExWindspeed.Options.html#t:device/0","title":"ExWindspeed.Options.device/0","type":"type","doc":"Device to read from, defaults to spidev0.0"},{"ref":"ExWindspeed.Options.html#t:implementation/0","title":"ExWindspeed.Options.implementation/0","type":"type","doc":"Specifies which implementation module to use. Current choices are: ExWindspeed.Platform.Host.SensorImpl ExWindspeed.Platform.RPI.SensorImpl - Default Custom modules may be used as long as they implement the ExWindspeed.Sensor behaviour."},{"ref":"ExWindspeed.Options.html#t:spi_transfer_payload/0","title":"ExWindspeed.Options.spi_transfer_payload/0","type":"type","doc":"Bitstring to send to the MCP3008 to instruct it which channel to read. Defaults to channel 0 &lt;&lt;0x01, 0x80, 0x00&gt;&gt;"},{"ref":"ExWindspeed.Options.html#t:t/0","title":"ExWindspeed.Options.t/0","type":"type","doc":""}]